#ifndef SWARM_H
#define SWARM_H
 
#include "mbed.h"
#include "N5110.h"
#include "Gamepad.h"
#include "Battleship.h"

/** Swarm Class  
* @brief Swarm 
* @author Haoyan Zhang  
* @date April, 2020 
*/ 

class Swarm
{
public:
       
       Swarm();
       ~Swarm();
       void init(int height, int width, int speed);
       void draw(N5110 &lcd);
       void update();
       void set_velocity(Vector2D v);
       Vector2D get_velocity();
       Vector2D get_pos();
       void set_pos(Vector2D p);
       
private:

        Vector2D _velocity;
        int _height;
        int _width;
        int _x;
        int _y;
};
#endif

       